/* IN55 - TP2 - Exo 1 */
/* Simple dessin */

#include <GL/glut.h>

/* Dfinitions */
void Reshape(int w,int h);
void Draw();

/* Fonction main */

int main( int argc, char **argv)
{
	//initialisation de Glut
	glutInit(&argc, argv);
	// Mode d'affichage
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);
	// Taille et position de la fentre
	glutInitWindowSize(640,480);
	glutInitWindowPosition(200,200);  
	// Cration de la fentre
	glutCreateWindow("IN55 TP2 - Introduction  OpenGL - Exo 1");
	// Couleur d'effacement du buffer
	glClearColor(0.,0.,0.,0.);
	// Fonction pour l'affichage
	glutDisplayFunc(Draw);
	// Fonction pour le redimentionnement
	glutReshapeFunc(Reshape);
	// Boucle de gestion des vnements
	glutMainLoop();
	
	return 0;
}

/* Affichage de la scne OpenGL */
void Draw()
{ 
	glClear(GL_COLOR_BUFFER_BIT); // Vide le buffer de couleur
	glMatrixMode(GL_MODELVIEW) ;
	glLoadIdentity();

	// Dfinition du point de vue
	/*
	gluLookAt(
		0.0, 0.0,-5.0, 	// Vue de face
		0.0, 0.0, 0.0, 	// On regarde le centre...
		0.0, 1.0, 0.0);	// ...verticalement
	*/
	gluLookAt(
		2.0, 2.0,-5.0, 	// Vue lgrement sur le ct
		0.0, 0.0, 0.0, 	// On regarde le centre...
		0.0, 1.0, 0.0);	// ...verticalement
		
	// Axes x, y et z
	glBegin(GL_LINES);
		glVertex3f(-10.0f,0.0f,0.0f); // dbut de x
		glVertex3f( 10.0f,0.0f,0.0f); // fin  de x
		glVertex3f(0.0f,-10.0f,0.0f); // dbut de y
		glVertex3f(0.0f, 10.0f,0.0f); // fin de y
		glVertex3f(0.0f,0.0f,-10.0f); // dbut de z
		glVertex3f(0.0f,0.0f, 10.0f); // fin de z
	glEnd();
		
	// On dessine un carr, avec une couleur pour chaque sommet
	glBegin(GL_QUADS);				// dbut du carr
		glColor3d(1.,0.,0.);			// rouge
		glVertex3f(-1.0f, 1.0f, 0.0f);	// haut-gauche
		glColor3d(0.,1.,0.);			// vert
		glVertex3f( 1.0f, 1.0f, 0.0f);	// haut-droit
		glColor3d(0.,0.,1.);			// bleu
		glVertex3f( 1.0f,-1.0f, 0.0f);	// bas-droit
		glColor3d(1.,1.,1.);			// blanc
		glVertex3f(-1.0f,-1.0f, 0.0f);	// bas-gauche	
	glEnd();						// fin du carr
	
	// nb : sans Z-buffer, le carr masque tous les axes
		
	glutSwapBuffers(); // Intervertit les deux tampons

	glutPostRedisplay();	// Demande de redessiner la scene
}

/* Redimentionnement */
void Reshape(int w, int h) 
{
	glMatrixMode(GL_MODELVIEW); 
	glLoadIdentity();
	glViewport(0,0,w,h);
	glMatrixMode(GL_PROJECTION); // On slectionne la matrice de 
								// projection
	glLoadIdentity();			// On initialise la matrice
	gluPerspective(45,(float) w/h,1.,500.);	// On rgle la perspective
}
